<?php

declare(strict_types=1);

namespace App\Entity\Database\Comments;

use App\Entity\Database\Posts\Post;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\Table;

#[Entity]
#[Table(name: "comments")]
class Comment
{
    public function __construct(
        #[Id,
    Column]
        public ?int $id,
        #[ManyToOne(targetEntity: Post::class, inversedBy: "comments")]
        public Post $post,
        #[Column(type: "text")]
        public string $name,
        #[Column(length: 320 /* see RFC5321 */)]
        public string $email,
        #[Column(type: "text")]
        public string $body,
    ) {
    }
}
