<?php

declare(strict_types=1);

namespace App\Entity\Database\Posts;

use App\Entity\Database\Comments\Comment;
use App\Entity\Database\Users\User;
use App\Repository\Post\PostRepository;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\OneToMany;
use Doctrine\ORM\Mapping\Table;

#[Entity(repositoryClass: PostRepository::class)]
#[Table(name: "posts")]
class Post
{
    public function __construct(
        #[Id,
    Column]
        public ?int $id,
        #[ManyToOne(targetEntity: User::class)]
        public User $user,
        #[Column(type: "text")]
        public string $title,
        #[Column(type: "text")]
        public string $body,
        /**
         * @var Collection<int, Comment> $comments
         */
        #[OneToMany(targetEntity: Comment::class, mappedBy: "post")]
        public Collection $comments,
    ) {
    }
}
