<?php

declare(strict_types=1);

namespace App\Entity\Database\Users;

use App\Repository\Users\CompanyRepository;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\OneToMany;
use Doctrine\ORM\Mapping\Table;

#[Entity(repositoryClass: CompanyRepository::class)]
#[Table(name: "companies")]
class Company
{
    public function __construct(
        #[Id,
    Column,
    GeneratedValue(strategy: "SEQUENCE")]
        public ?int $id,
        /**
         * @var Collection<int, User> $users
         */
        #[OneToMany(targetEntity: User::class, mappedBy: 'company')]
        public Collection $users,
        // TODO: prepokladam ze tohle muzu povazovat za klic a vsechny dalsi parametry budou stejne pro kazdou company se stejnym jmenem
        #[Column(type: "text", unique: true)]
        public string $name,
        #[Column(type: "text")]
        public string $catchPhrase,
        #[Column(type: "text")]
        public string $bs,
    ) {
    }
}
