<?php

declare(strict_types=1);

namespace App\Entity\Database\Users;

use App\Repository\Users\UserRepository;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\OneToOne;
use Doctrine\ORM\Mapping\Table;

#[Entity(repositoryClass: UserRepository::class)]
#[Table(name: "users")]
class User
{
    public function __construct(
        #[Id,
    Column]
        public ?int $id,
        #[Column(type: "text")] // TODO: type: text is really non-optimal. But there is no docs for api
        public string $name,
        #[Column(type: "text")]
        public string $username,
        #[Column(type: "text")]
        public string $email,
        #[Column(type: "text")]
        public string $phone,
        #[Column(type: "text")]
        public string $website,
        #[OneToOne(targetEntity: Address::class, inversedBy: "user")]
        public Address $address,
        #[ManyToOne(targetEntity: Company::class, inversedBy: "users")]
        public Company $company,
    ) {
        if (empty($this->address->user)) {
            $this->address->user = $this;
        }
    }
}
