<?php

declare(strict_types=1);

namespace App\Repository\Post;

use App\Entity\Database\Posts\Post;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * In case of deleting records, you must modify RefreshDatabaseCommand transaction logic
 * @extends ServiceEntityRepository<Post>
 */
class PostRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Post::class);
    }

    /**
     * @param int $page
     * @param int $pageSize
     * @return array<Post>
     */
    public function getPaginatedPosts(int $page, int $pageSize): array
    {
        $query = $this->createQueryBuilder('p')
            ->orderBy('p.id', 'DESC')
            ->setFirstResult(($page - 1) * $pageSize)
            ->setMaxResults($pageSize)
            ->getQuery();

        return $query->getResult();
    }
}
